
Smart Proxy - Bug #2494

foreman proxy returning html instead of JSON

05/13/2013 10:27 AM - cristian falcas

Status: Rejected   

Priority: Normal   

Assignee:    

Category: API   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

When trying to add a smart proxy in foreman, I get this error:

Unable to save

No features found on this proxy, please make sure you enable at least one feature

here is the output from curl and the production.log file:

curl k -H "Content-Type:application/json" -H "Accept:application/json"  https://foremanhost:8443/features

<!DOCTYPE html PUBLIC "//W3C//DTD XHTML 1.0 Transitional//EN" "

http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;>

<html>

<head>

<title>DHCP Web interface</title>

<link href='/css/styles.css' rel='stylesheet' />

</head>

<body>

<div id='wrapper'>

<div id='header'>

<h1>DHCP Browser</h1>

<div id='nav'>

<ol>

<a href='/dhcp'>     <li>Home</li> </a>

<a href='/features'> <li>Features</li> </a>

</ol>

</div>

</div>

<div id='content'>

<h2>Suported features</h2>

<ul>

&lt;li&gt;puppet&lt;/li&gt;

 
&lt;li&gt;puppetca&lt;/li&gt;

 
&lt;li&gt;tftp&lt;/li&gt;

 </ul>

&lt;/div&gt;

      &lt;div id=&#039;footer&#039;&gt;

        &lt;p&gt; &copy; 2010 &lt;a href=&#039;mailto:ohadlevy@gmail.com

&#039;&gt; Ohad Levy &lt;/a&gt; &lt;/p&gt;

      &lt;/div&gt;

    &lt;/div&gt;

  &lt;/body&gt;

&lt;/html&gt;
 /var/log/foreman/production.log:

Failed to parse response: <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0

Transitional//EN"

"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html>

<head>

<title>DHCP Web interface</title>

<link href='/css/styles.css' rel='stylesheet' />

</head>

<body>

<div id='wrapper'>

<div id='header'>

<h1>DHCP Browser</h1>

<div id='nav'>

<ol>

<a href='/dhcp'>     <li>Home</li> </a>

<a href='/features'> <li>Features</li> </a>

</ol>

</div>

</div>

<div id='content'>

<h2>Suported features</h2>

<ul>

&lt;li&gt;puppet&lt;/li&gt;

 
&lt;li&gt;puppetca&lt;/li&gt;

 
&lt;li&gt;tftp&lt;/li&gt;

 </ul>

&lt;/div&gt;

      &lt;div id=&#039;footer&#039;&gt;

        &lt;p&gt; &copy; 2010 &lt;a href=&#039;mailto:ohadlevy@gmail.com

&#039;&gt; Ohad Levy &lt;/a&gt; &lt;/p&gt;

      &lt;/div&gt;

    &lt;/div&gt;

  &lt;/body&gt;

&lt;/html&gt;

 > 757: unexpected token at '&lt;!DOCTYPE html PUBLIC &quot;//W3C//DTD XHTML

1.0 Transitional//EN" 

"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

&lt;html&gt;

  &lt;head&gt;

    &lt;title&gt;DHCP Web interface&lt;/title&gt;

    &lt;link href=&#039;/css/styles.css&#039; rel=&#039;stylesheet&#039; /&gt;

  &lt;/head&gt;

  &lt;body&gt;

    &lt;div id=&#039;wrapper&#039;&gt;

      &lt;div id=&#039;header&#039;&gt;

        &lt;h1&gt;DHCP Browser&lt;/h1&gt;

        &lt;div id=&#039;nav&#039;&gt;

          &lt;ol&gt;

            &lt;a href=&#039;/dhcp&#039;&gt;     &lt;li&gt;Home&lt;/li&gt; &lt;/a&gt;

            &lt;a href=&#039;/features&#039;&gt; &lt;li&gt;Features&lt;/li&gt; &lt;/a&gt;

          &lt;/ol&gt;

        &lt;/div&gt;

      &lt;/div&gt;

      &lt;div id=&#039;content&#039;&gt;

        &lt;h2&gt;Suported features&lt;/h2&gt;

&lt;ul&gt;

 
&lt;li&gt;puppet&lt;/li&gt;

 
&lt;li&gt;puppetca&lt;/li&gt;
&lt;li&gt;tftp&lt;/li&gt;

 </ul>

&lt;/div&gt;

      &lt;div id=&#039;footer&#039;&gt;

        &lt;p&gt; &copy; 2010 &lt;a href=&#039;mailto:ohadlevy@gmail.com

&#039;&gt; Ohad Levy &lt;/a&gt; &lt;/p&gt;

      &lt;/div&gt;

    &lt;/div&gt;

  &lt;/body&gt;

&lt;/html&gt;

'

Failed to save: No features found on this proxy, please make sure you enable at least one feature

History

#1 - 05/13/2013 10:42 AM - Dominic Cleal

- Project changed from Foreman to Smart Proxy

#2 - 05/13/2013 10:42 AM - Dominic Cleal

- Category set to API

- Status changed from New to Feedback

This looks like the issue here: https://github.com/theforeman/smart-proxy/pull/73

Which version of Sinatra are you using?

#3 - 05/13/2013 12:34 PM - cristian falcas

Sorry, I forgot to say the versions. Sinatra is rubygem-sinatra-1.0-2.el6.noarch.

Packages (ruby and foreman) installed (on Oracle Linux Server release 6.4):

foreman-1.1stable-3.el6.noarch

foreman-installer-1.1.2-1.noarch

foreman-proxy-1.1stable-1.el6.noarch

foreman-sqlite-1.1stable-3.el6.noarch

libselinux-ruby-2.0.94-5.3.el6.x86_64

ruby-1.8.7.352-4.el6.x86_64

ruby19-1.9.2p290-1.el6.x86_64

ruby-augeas-0.4.1-1.el6.x86_64

rubygem-abstract-1.0.0-1.el6.noarch

rubygem-actionmailer-3.0.20-1.el6.noarch

rubygem-actionpack-3.0.20-1.el6.noarch

rubygem-activemodel-3.0.20-1.el6.noarch

rubygem-activerecord-3.0.20-1.el6.noarch

rubygem-activeresource-3.0.20-1.el6.noarch

rubygem-activesupport-3.0.20-1.el6.noarch

rubygem-acts_as_audited-2.0.0-1.el6.noarch

rubygem-ancestry-1.3.0-1.el6.noarch

rubygem-apipie-rails-0.0.13-1.el6.noarch

rubygem-arel-2.0.10-1.el6.noarch

rubygem-audited-3.0.0.rc1-1.el6.noarch

rubygem-audited-activerecord-3.0.0.rc1-1.el6.noarch

rubygem-builder-2.1.2-1.el6.noarch

rubygem-bundler-1.0.15-1.el6.noarch

rubygem-erubis-2.6.6-1.el6.noarch

rubygem-fastthread-1.0.7-2.el6.x86_64

rubygem-highline-1.4.0-2.el6.noarch

rubygem-i18n-0.5.0-1.el6.noarch

rubygem-jquery-rails-1.0.19-1.el6.noarch

rubygem-json-1.6.8-1.el6.x86_64

rubygem-mail-2.3.3-2.el6.noarch

rubygem-mime-types-1.18-1.el6.noarch

rubygem-multi_json-1.2.0-1.el6.noarch

rubygem-net-ldap-0.3.1-1.el6.noarch

rubygem-oauth-0.4.7-1.el6.noarch

rubygem-passenger-3.0.17-2.el6.1.x86_64

rubygem-passenger-native-3.0.17-2.el6.1.x86_64

rubygem-passenger-native-libs-3.0.17-2.el6.1.x86_64
rubygem-polyglot-0.3.3-1.el6.noarch

rubygem-rabl-0.7.5-1.el6.noarch

rubygem-rack-1.2.5-4.el6.noarch

rubygem-rack-mount-0.6.14-1.el6.noarch

rubygem-rack-test-0.5.7-2.el6.noarch

rubygem-rails-3.0.20-1.el6.noarch

rubygem-railties-3.0.20-1.el6.noarch

rubygem-rake-0.9.2.2-2.el6.noarch

rubygem-rdoc-3.12-2.el6.x86_64

rubygem-rest-client-1.6.7-1.el6.noarch

rubygem-ruby2ruby-2.0.1-1.el6.noarch

rubygem-ruby_parser-3.0.1-2.el6.noarch

rubygems-1.8.10-1.el6.noarch

rubygem-safemode-1.2.0-1.el6.noarch

rubygem-scoped_search-2.4.0-1.el6.noarch

rubygem-sexp_processor-4.1.2-1.el6.noarch

rubygem-sinatra-1.0-2.el6.noarch

rubygem-sqlite3-1.3.5-2.el6.x86_64

rubygem-thor-0.14.6-2.el6.noarch

rubygem-treetop-1.4.9-1.el6.noarch

rubygem-tzinfo-0.3.32-1.el6.noarch

rubygem-uuidtools-2.1.1-1.el6.noarch

rubygem-will_paginate-3.0.3-1.el6.noarch

ruby-irb-1.8.7.352-4.el6.noarch

ruby-libs-1.8.7.352-4.el6.x86_64

ruby-rdoc-1.8.7.352-4.el6.noarch

ruby-shadow-1.4.1-13.el6.x86_64

#4 - 05/13/2013 12:39 PM - Dominic Cleal

Can you do a `gem list` too, in case it's been installed that way?

#5 - 05/14/2013 03:58 AM - cristian falcas

thank you.

I had sinatra-1.4.2 installed manually it seems. I removed the manually installed one and now it works (with sinatra (1.0)).

#6 - 05/14/2013 05:10 AM - Dominic Cleal

- Status changed from Feedback to Rejected

Thanks for confirming, glad it's sorted!
